# Program to identify SS bonds in a PDB file
import math

# Reads and opens input file
pdbFileIn = input("\nType the PDB file name => ")
fo = open(pdbFileIn,"r")

# Assigns 0 to counter variables
count_SS_bonds = 0
count_SG = 0

# Sets up lists for atomic coordinates of SG
ss_x = []
ss_y = []
ss_z = []

# Looping through atoms to identify SS bonds
for line in fo:
    if line[0:6] == "ATOM  " and line[13:15] == "SG" and (float(line[56:60]) > 0.50) : 
        ss_x.append(float(line[30:38]))
        ss_y.append(float(line[38:46]))
        ss_z.append(float(line[46:54]))
        count_SG += 1

# Closes file
fo.close()

# Looping through the SG atoms
for i in range(count_SG):
    for j in range(i+1,count_SG):
        distance_SS = math.sqrt((ss_x[i]-ss_x[j])**2+(ss_y[i]-ss_y[j] )**2+(ss_z[i]-ss_z[j])**2)
        if distance_SS < 2.1 and distance_SS > 2.0:
            count_SS_bonds += 1
                                  
# Shows results
print("\nNumber of S-S bonds identified in ",pdbFileIn,": ",count_SS_bonds)