# Program to read a PDB file and identify SS bonds

import math

# Reads and opens input file
pdbFileIn = input("\nType the PDB file name => ")
fo = open(pdbFileIn,"r")

# Assigns 0 to counter variables
count_SS_bonds = 0
count_SG = 0

# Sets up lists for atomic coordinates of SG and number of residue
ss_x = []
ss_y = []
ss_z = []
ss_res_number = []
ss_line = []

# Looping through atoms to identify SS bonds
for line in fo:
    if line[0:6] == "ATOM  " and line[13:15] == "SG" and (float(line[56:60]) > 0.50) :
        ss_x.append(float(line[30:38]))
        ss_y.append(float(line[38:46]))
        ss_z.append(float(line[46:54]))
        ss_res_number.append(line[22:26])
        ss_line.append(line)
        count_SG += 1

# Closes file
fo.close()

# Prints header to show a table with results
print("\nPairs of cysteines participating in SS-bonds identified in the file: ",pdbFileIn)
print("\nCysteine 1\tCysteine 2\t Distance(A)")

# Looping through the SG atoms
for i in range(count_SG):
    for j in range(i+1,count_SG):
        distance_SS = math.sqrt((ss_x[i]-ss_x[j])**2+(ss_y[i]-ss_y[j] )**2+(ss_z[i]-ss_z[j])**2)
        if distance_SS < 2.1 and distance_SS > 2.0:
            count_SS_bonds += 1
            print(ss_line[i][22:26],"\t\t",ss_line[j][22:26],"\t\t%8.3f"%distance_SS)
                                  
# Shows final result
print("\nTotal number of S-S bonds identified in ",pdbFileIn,": ",count_SS_bonds)
